if ("undefined" == typeof(DealFinderComboLocalLoader)) 
{
	var DealFinderComboLocalLoader = 
	{
		onLoad : function()
		{
			try 
			{
				// Query available and selected locales
				var chromeRegService = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService();
				var xulChromeReg = chromeRegService.QueryInterface(Components.interfaces.nsIXULChromeRegistry);
				var toolkitChromeReg = chromeRegService.QueryInterface(Components.interfaces.nsIToolkitChromeRegistry);
				var prefManager = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefBranch);
				var selectedLocale = prefManager.getCharPref("extensions.dealfindercombo.locale");
				var availableLocales = toolkitChromeReg.getLocalesForPackage("dealfindercombo");

				// Render locale menulist
				var XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
				
				var localeListbox = document.getElementById("locale-listbox");
				if(null != localeListbox)
				{
					var selectedItem = null;
						
					while(availableLocales.hasMore()) 
					{			
						var locale = availableLocales.getNext();
						var listitem = document.createElementNS(XUL_NS, "listitem");
						listitem.setAttribute("value", locale);
						listitem.setAttribute("label", this.getLocationName(locale));
						listitem.setAttribute("class", "listitem-iconic");
						listitem.setAttribute("image", "chrome://dealfindercombo/skin/flags/" + locale + ".png" );
						if (locale == selectedLocale) 
						{
							selectedItem = listitem;
						}			
						localeListbox.appendChild(listitem);
					}
					localeListbox.selectedItem = selectedItem;
				}
			} 
			catch (err) 
			{
				alert ("Failed to render Location List: " + err);
			}
		},
    /**
     * Change locale.
     * */
    changeLocale:function()
    {
        try 
				{
					var localeListbox = document.getElementById("locale-listbox");
					var newLocale = localeListbox.selectedItem.value;

					var prefs = Components.classes["@mozilla.org/preferences-service;1"].
								getService(Components.interfaces.nsIPrefBranch);
					prefs.setCharPref("extensions.dealfindercombo.locale", newLocale);
          prefs.setBoolPref("extensions.dealfindercombo.reloadList", true);
//          dealFinderComboExtension.dealFinderComboModule.rebuildChildren = true;
          close();
				}
				catch(err) 
				{	
					alert("Could not change Location: "+err);
				}
    },
		getLocationName : function(loc)
		{
			switch (loc) 
			{
				case 'en-US':
					return 'Amazon USA';
				case 'en-GB':
					return 'Amazon UK';
				case 'en-CA':
					return 'Amazon Canada';
				case 'fr':
					return 'Amazon France';
				case 'de':
					return 'Amazon Germany';
				case 'it':
					return 'Amazon Italy';
				default:
					return 'Amazon USA';
			}
		}
	}
};
window.addEventListener("load", function() { DealFinderComboLocalLoader.onLoad();}, false);
