"use strict";

// The only global object for this extension.
var dealFinderComboExtension = {};
(   
	function() 
	{
    const dealFinderPrefPrefix = "dealFinderExtension";
    const dealFinderPrefTBItemInstalled = dealFinderPrefPrefix+".toolbarItemInstalled";
    const dealFinderComboButtonId = "dealFinderComboButton";
    const ffToolBarID = "nav-bar";
		// Registration
		var namespaces = [];
		this.ns = function(fn) 
		{
			var ns = {};
			namespaces.push(fn, ns);
			return ns;
		};
    /**
     * Function to install toolbar button on first start.
     * */
    this.installTbButton = function()
    {
      var tbElem = document.getElementById(ffToolBarID);
      var tbItemElem = document.getElementById(dealFinderComboButtonId);
      if (tbElem && !tbItemElem)
      {
        var newSet = tbElem.currentSet + "," + dealFinderComboButtonId;
        tbElem.setAttribute("currentset", newSet);
        tbElem.currentSet = newSet;
        document.persist(ffToolBarID, "currentset");
        nsPreferences.setBoolPref(dealFinderPrefTBItemInstalled, true);
        try {
          BrowserToolboxCustomizeDone(true);
        } catch (e) {
          // TODO trace exception here
        }
      }

    };
		// Initialization
		this.initialize = function() 
		{
      var tbItemInstalled;
      try{
        var nsPreferences = Components.classes["@mozilla.org/preferences-service;1"].
            getService(Components.interfaces.nsIPrefBranch);
        tbItemInstalled = nsPreferences.getBoolPref(dealFinderPrefTBItemInstalled, false);
      }catch(e)
      {
        
      }
      if (!tbItemInstalled)
      {
        setTimeout(function()
          {
            var tbElem = document.getElementById(ffToolBarID);
            var tbItemElem = document.getElementById(dealFinderComboButtonId);
            if (tbElem && !tbItemElem)
            {
              var newSet = tbElem.currentSet + "," + dealFinderComboButtonId;
              tbElem.setAttribute("currentset", newSet);
              tbElem.currentSet = newSet;
              document.persist(ffToolBarID, "currentset");
              nsPreferences.setBoolPref(dealFinderPrefTBItemInstalled, true);
              try {
                BrowserToolboxCustomizeDone(true);
              } catch (e) {
                // TODO trace exception here
              }
            }
          }, 0);
      }
      
			for (var i=0; i<namespaces.length; i+=2) 
			{
				var fn = namespaces[i];
				var ns = namespaces[i+1];
				fn.apply(ns);
			}
		};

		// Clean up
		this.shutdown = function() 
		{
			window.removeEventListener("load", dealFinderComboExtension.initialize, false);
			window.removeEventListener("unload", dealFinderComboExtension.shutdown, false);
			
		};

		// Register handlers to maintain extension life cycle.
		window.addEventListener("load", dealFinderComboExtension.initialize, false);
		window.addEventListener("unload", dealFinderComboExtension.shutdown, false);
	}
).apply(dealFinderComboExtension);
