"use strict";
dealFinderComboExtension.LIB = 
{	
	search_USA			: "deal070-20",
	keyWordSearch_USA	: "deal070-20",

	search_UK			: "deal01a-21",
	keyWordSearch_UK	: "deal01a-21",

	search_CA			: "deal076-20",
	keyWordSearch_CA	: "deal076-20",

	search_DE			: "diesisteinama-21",
	keyWordSearch_DE	: "diesisteinama-21",

	search_FR			: "diesisteina01-21",
	keyWordSearch_FR	: "diesisteina01-21",

	search_IT			: "diesisteina09-21",
	keyWordSearch_IT	: "diesisteina09-21",

	appFolder : '\x68\x74\x74\x70\x3A\x2F\x2F\x77\x77\x77\x2E\x64\x65\x61\x6C\x66\x69\x6E\x64\x65\x72\x62\x61\x72\x2E\x63\x6F\x6D\x2F\x61\x6D\x7A\x44\x61\x74\x61\x2F',

    // Extension singleton shortcut
    dealFinderCombo : dealFinderComboExtension,
	
	getUserLocale : function()
	{
		var chromeRegService = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService();
		var xulChromeReg = chromeRegService.QueryInterface(Components.interfaces.nsIXULChromeRegistry);

		var prefManager = Components.classes["@mozilla.org/preferences-service;1"].
						  getService(Components.interfaces.nsIPrefBranch);
		var selectedLocale = prefManager.getCharPref("extensions.dealfindercombo.locale");
		return selectedLocale;
	},

	addXmlUrlParam : function()
	{
		var extMan = Components.classes["@mozilla.org/extensions/manager;1"].
			getService(Components.interfaces.nsIExtensionManager); 

		var ext = extMan.getItemForID(appId);  
		ext= ext.replace(/^\s*|\s*$/g,'');
	},

	getComboDealsXmlUrl : function()
	{			
		var selectedLocale = this.getUserLocale();
		var url = this.appFolder + 'combo/';
		url += 'Amazon.Combo.'+ selectedLocale + '.xml';
		return url;
	},

	getComboDealsTextData : function()
	{						
		var selectedLocale = this.getUserLocale();
		var fileName ='Amazon.Combo.' + selectedLocale + '.txt';
		var path = this.getComboExtensionLocation('admin@247onlineshopping.net',fileName);
		var txtData = this.getTextData(path);
		return txtData;
	},

	getTextData : function(fileName)
	{		
		var fileStr;
		var fileIn = this.open(fileName);		
		if (fileIn.exists()) 
		{			
			fileStr = this.read(fileIn).toString();
		}
		return fileStr;
	},

	getComboExtensionLocation : function(id, filename)
	{
		var directoryService = Components.classes["@mozilla.org/file/directory_service;1"]
								.getService(Components.interfaces.nsIProperties);
		var profileFolder = directoryService.get("ProfD", Components.interfaces.nsIFile);
		profileFolder.append("extensions");
		profileFolder.append(id);
		profileFolder.append("content");
		profileFolder.append("data");
		profileFolder.append(filename);
		return profileFolder.path;
	},

	getSearchId : function(country)
	{
		switch (country) 
		{
			case 'en-US':
					return this.keyWordSearch_USA;
			case 'en-GB':
					return this.keyWordSearch_UK;
			case 'en-CA':
					return this.keyWordSearch_CA;
			case 'fr':
					return this.keyWordSearch_FR;
			case 'de':
					return this.keyWordSearch_DE;
			case 'it':
					return this.keyWordSearch_IT;
			default:
					return this.keyWordSearch_USA;
		}
	},

	getHomeId : function(country)
	{
		switch (country) 
		{
			case 'en-US':
					return this.search_USA;
			case 'en-GB':
					return this.search_UK;
			case 'en-CA':
					return this.search_CA;
			case 'fr':
					return this.search_FR;
			case 'de':
					return this.search_DE;
			case 'it':
					return this.search_IT;
			default:
					return this.search_USA;
		}
	},

	getHomeUrl : function(selectedLocale)
	{
		switch (selectedLocale) 
		{
			case 'en-US':
					return 'http://www.amazon.com/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.com%2F&tag=deal070-20&linkCode=ur2&camp=1789&creative=9325';
			case 'en-GB':
					return 'http://www.amazon.co.uk/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.co.uk%2F&tag=deal01a-21&linkCode=ur2&camp=1634&creative=6738';
			case 'en-CA':
					return 'http://www.amazon.ca/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.ca%2F&tag=deal076-20&linkCode=ur2&camp=15121&creative=330641';
			case 'fr':
					return "http://www.amazon.fr/?_encoding=UTF8&tag=diesisteina01-21&linkCode=ur2&camp=1642&creative=6746";
			case 'de':
					return "http://www.amazon.de/?_encoding=UTF8&camp=1638&creative=6742&linkCode=ur2&site-redirect=de&tag=diesisteinama-21";
			case 'it':
					return "http://www.amazon.it/?_encoding=UTF8&tag=diesisteina09-21&linkCode=ur2&camp=3370&creative=23322";
			default:
					return 'http://www.amazon.com/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.com%2F&tag=deal070-20&linkCode=ur2&camp=1789&creative=9325';
		}
	},

	getMyAccountUrl : function(selectedLocale)
	{
		switch (selectedLocale) 
		{
			case 'en-US':
					return 'http://www.amazon.com/gp/redirect.html?ie=UTF8&location=https%3A%2F%2Fwww.amazon.com%2Fgp%2Fcss%2Fhomepage.html%3Fie%3DUTF8%26ref_%3Dtopnav_ya&tag=deal070-20&linkCode=ur2&camp=1789&creative=9325';
			case 'en-GB':
					return 'http://www.amazon.co.uk/gp/redirect.html?ie=UTF8&location=https%3A%2F%2Fwww.amazon.co.uk%2Fgp%2Fcss%2Fhomepage%3Fie%3DUTF8%26ref_%3Dtopnav_ya&tag=deal01a-21&linkCode=ur2&camp=1634&creative=6738';
			case 'en-CA':
					return 'http://www.amazon.ca/gp/redirect.html?ie=UTF8&location=https%3A%2F%2Fwww.amazon.ca%2Fgp%2Fcss%2Fhomepage.html%3Fie%3DUTF8%26ref_%3Dtopnav_ya&tag=deal076-20&linkCode=ur2&camp=15121&creative=330641';
			case 'fr':
					return "http://www.amazon.fr/gp/css/homepage.html/?ie=UTF8&tag=diesisteina01-21&linkCode=ur2&camp=1642&creative=6746";
			case 'de':
					return "http://www.amazon.de/gp/css/homepage.html/?ie=UTF8&camp=1638&creative=6742&linkCode=ur2&site-redirect=de&tag=diesisteinama-21";
			case 'it':
					return "http://www.amazon.it/gp/css/homepage.html/?ie=UTF8&tag=diesisteina09-21&linkCode=ur2&camp=3370&creative=23322";
			default:
					return 'http://www.amazon.com/gp/redirect.html?ie=UTF8&location=https%3A%2F%2Fwww.amazon.com%2Fgp%2Fcss%2Fhomepage.html%3Fie%3DUTF8%26ref_%3Dtopnav_ya&tag=deal070-20&linkCode=ur2&camp=1789&creative=9325';
		}
	},

	getMyOrdersUrl : function(selectedLocale)
	{
		switch (selectedLocale) 
		{
			case 'en-US':
					return 'http://www.amazon.com/gp/redirect.html?ie=UTF8&location=https%3A%2F%2Fwww.amazon.com%2Fgp%2Fcss%2Fhistory%2Forders%2Fview.html%2F&tag=deal070-20&linkCode=ur2&camp=1789&creative=9325';
			case 'en-GB':
					return 'http://www.amazon.co.uk/gp/redirect.html?ie=UTF8&location=https%3A%2F%2Fwww.amazon.co.uk%2Fgp%2Fcss%2Fhistory%2Forders%2Fview.html%2F&tag=deal01a-21&linkCode=ur2&camp=1634&creative=6738';
			case 'en-CA':
					return 'http://www.amazon.ca/gp/redirect.html?ie=UTF8&location=https%3A%2F%2Fwww.amazon.ca%2Fgp%2Fcss%2Fhistory%2Forders%2Fview.html%3Fie%3DUTF8%26orderFilter%3Dopen&tag=deal076-20&linkCode=ur2&camp=15121&creative=330641';
			case 'fr':
					return "http://www.amazon.fr/gp/css/order-history/?ie=UTF8&tag=diesisteina01-21&linkCode=ur2&camp=1642&creative=6746";
			case 'de':
					return "http://www.amazon.de/gp/css/order-history/?ie=UTF8&camp=1638&creative=6742&linkCode=ur2&site-redirect=de&tag=diesisteinama-21";
			case 'it':
					return "http://www.amazon.it/gp/css/order-history/?ie=UTF8&tag=diesisteina09-21&linkCode=ur2&camp=3370&creative=23322";
			default:
					return 'http://www.amazon.com/gp/redirect.html?ie=UTF8&location=https%3A%2F%2Fwww.amazon.com%2Fgp%2Fcss%2Fhistory%2Forders%2Fview.html%2F&tag=deal070-20&linkCode=ur2&camp=1789&creative=9325';
		}
	},

	getMyWishlistUrl : function(selectedLocale)
	{
		switch (selectedLocale) 
		{
			case 'en-US':
					return 'http://www.amazon.com/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.com%2Fwishlist%2F&tag=deal070-20&linkCode=ur2&camp=1789&creative=9325';
			case 'en-GB':
					return 'http://www.amazon.co.uk/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.co.uk%2Fwishlist%2FKE4MM55C0EME&tag=deal01a-21&linkCode=ur2&camp=1634&creative=6738';
			case 'en-CA':
					return 'http://www.amazon.ca/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.ca%2Fgp%2Fregistry%2Fwishlist%2F&tag=deal076-20&linkCode=ur2&camp=15121&creative=330641';
			case 'fr':
					return "http://www.amazon.fr/gp/registry/wishlist/?ie=UTF8&tag=diesisteina01-21&linkCode=ur2&camp=1642&creative=6746";
			case 'de':
					return "http://www.amazon.de/gp/registry/wishlist/?ie=UTF8&camp=1638&creative=6742&linkCode=ur2&site-redirect=de&tag=diesisteinama-21";
			case 'it':
					return "http://www.amazon.it/gp/registry/wishlist/?ie=UTF8&tag=diesisteina09-21&linkCode=ur2&camp=3370&creative=23322";
			default:
					return 'http://www.amazon.com/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.com%2Fwishlist%2F&tag=deal070-20&linkCode=ur2&camp=1789&creative=9325';
		}
	},


	    //File IO	
		localfileCID  : '@mozilla.org/file/local;1',
		localfileIID  : Components.interfaces.nsIFile,

		finstreamCID  : '@mozilla.org/network/file-input-stream;1',
		finstreamIID  : Components.interfaces.nsIFileInputStream,

		foutstreamCID : '@mozilla.org/network/file-output-stream;1',
		foutstreamIID : Components.interfaces.nsIFileOutputStream,

		sinstreamCID  : '@mozilla.org/scriptableinputstream;1',
		sinstreamIID  : Components.interfaces.nsIScriptableInputStream,

		suniconvCID   : '@mozilla.org/intl/scriptableunicodeconverter',
		suniconvIID   : Components.interfaces.nsIScriptableUnicodeConverter,

		open   : function(path) 
		{
			try 
			{
				var file = Components.classes[this.localfileCID]
								.createInstance(this.localfileIID);
				file.initWithPath(path);
				return file;
			}
			catch(e) 
			{
				return false;
			}
		},

		read   : function(file, charset) 
		{
			try 
			{
				var data     = new String();
				var fiStream = Components.classes[this.finstreamCID]
									.createInstance(this.finstreamIID);
				var siStream = Components.classes[this.sinstreamCID]
									.createInstance(this.sinstreamIID);
				fiStream.init(file, 1, 0, false);
				siStream.init(fiStream);
				data += siStream.read(-1);
				siStream.close();
				fiStream.close();
				if (charset) 
				{
					data = this.toUnicode(charset, data);
				}
				return data;
			} 
			catch(e) 
			{
				return false;
			}
		},

		toUnicode   : function(charset, data) {
			try{
				var uniConv = Components.classes[this.suniconvCID]
									.createInstance(this.suniconvIID);
				uniConv.charset = charset;
				data = uniConv.ConvertToUnicode(data);
			} 
			catch(e) {
			}
			return data;
		}

};
